#NoEnv
#NoTrayIcon
#SingleInstance ignore
SetWorkingDir,%A_ScriptDir%
Splitpath, A_ScriptFullPath,,,,title

ifnotexist,%title%.ini
{
	msgbox,can't find %title%.ini. major problem. please re-download distribution.
	exitapp
}

IniRead, Overwrite, %title%.ini, SETTINGS, Overwrite,0
IniRead, Folder1, %title%.ini, SYSTEM, SourceFolder,C:\Chaos
IniRead, Folder2, %title%.ini, SYSTEM, TargetFolder,C:\Sorted Files

Gui, Add, Edit, readonly x16 y27 w310 h20 vFolder1, %Folder1%
Gui, Add, Edit, readonly x16 y87 w310 h20 vFolder2, %Folder2%
Gui, Add, GroupBox, x6 y7 w360 h50 , Source
Gui, Add, GroupBox, x6 y67 w360 h50 , Target
Gui, Add, Button, gEditIni vEditIni x386 y17 w100 h20 , Edit INI
Gui, Add, Button, gMoveIt vMoveIt x386 y47 w100 h30 , I like to move it
Gui, Add, Button, gGuiClose x386 y87 w100 h20 , Bye!
Gui, Add, Button, gSelectFolder1 vSelectFolder1 x336 y27 w20 h20 , ...
Gui, Add, Button, gSelectFolder2 vSelectFolder2 x336 y87 w20 h20 , ...
; Generated using SmartGUI Creator 4.0
Gui, Add, StatusBar,,Ready
Gui, Show, h146 w495, %title%
Return

GuiEscape:
GuiClose:
ExitApp
Return

SelectFolder1:
FileSelectFolder, Folder1, *%Folder1%,0,Select Source Folder
If ErrorLevel <> 0
	Return
GuiControl,,Folder1,%Folder1%
return

SelectFolder2:
FileSelectFolder, Folder2, *%Folder2%,1,Select Target Folder
If ErrorLevel <> 0
	Return
GuiControl,,Folder2,%Folder2%
return


EditIni:
gui,submit
IniWrite, %Folder1%, %title%.ini, SYSTEM, SourceFolder
IniWrite, %Folder2%, %title%.ini, SYSTEM, TargetFolder
run,notepad %title%.ini
ExitApp



MoveIt:
Gui,Submit,NoHide
SB_SetText("I am moving it... Please wait!")
GuiControl,+disabled,EditIni
GuiControl,+disabled,MoveIT
GuiControl,+disabled,SelectFolder1
GuiControl,+disabled,SelectFolder2
IniWrite, %Folder1%, %title%.ini, SYSTEM, SourceFolder
IniWrite, %Folder2%, %title%.ini, SYSTEM, TargetFolder
Gosub,Extended
Gosub,Normal
Gosub,Folder
GuiControl,-disabled,EditIni
GuiControl,-disabled,MoveIT
GuiControl,-disabled,SelectFolder1
GuiControl,-disabled,SelectFolder2
SB_SetText("Ready")
Return


Extended:
Loop,99
{
	IniRead, input, %title%.ini, Extended, extended%a_index%,%A_space%
	if input =
		Continue
	StringSplit,input,input,~

	Loop,%folder1%\*.%input2%,0,0
	{
		StringReplace,Base,A_LoopFileName,.%A_LoopFileExt%
		count = 0
		Loop,%folder1%\%base%.*,0,0
			count := count +1

		if count < 2
			base = 

		IfNotExist,%Folder2%\%input1%\%base%
			FileCreateDir,%Folder2%\%input1%\%base%
		FileMove,%A_LoopFileFullPath%,%folder2%\%input1%\%base%\%A_LoopFileName%,%Overwrite%

		if count > 1
		{
			Loop,%folder1%\%base%.*,0,0
			{
				Ignore = %ignore%%A_LoopFileFullPath%
				FileMove,%A_LoopFileFullPath%,%folder2%\%input1%\%base%\%A_LoopFileName%,%Overwrite%
			}
		}
	}
}
Return



Normal:
Loop,99
{
	IniRead, input, %title%.ini, Normal, normal%a_index%,%A_space%
	if input =
		Continue
	StringSplit,input,input,~

	Loop,%folder1%\*.%input2%,0,0
	{
		If ignore contains %A_LoopFileFullPath%   ; do not move files which belong to extended
			Continue						  ; but could not be moved (no overwrite)
		IfNotExist,%Folder2%\%input1%
			FileCreateDir,%Folder2%\%input1%
		FileMove,%A_LoopFileFullPath%,%folder2%\%input1%\%A_LoopFileName%,%Overwrite%
	}
}
Ignore =
Return


Folder:
IniRead, input, %title%.ini, Folder, folder,_folders
Loop,%folder1%\*.*,2,0
{
	IfNotExist,%Folder2%\%input%
		FileCreateDir,%Folder2%\%input%
	FileMoveDir,%A_LoopFileFullPath%,%folder2%\%input%\,1
}
Return


GuiDropFiles:
Loop, parse, A_GuiEvent, `n
{
    FirstFile = %A_LoopField%
    Break
}
FileGetAttrib, FirstFileAttribute,%FirstFile%
If FirstFileAttribute not contains D
	SplitPath, FirstFile,, RenameFolder
else
	RenameFolder := FirstFile
If A_GuiControl = Folder1
	GuiControl,,Folder1,%RenameFolder%
If A_GuiControl = Folder2
	GuiControl,,Folder2,%RenameFolder%
Return